<template>
  <div v-if="loading">{{ t("loading images") }}</div>

  <transition-group
      v-else-if="currentPicture"
      class="pic-container"
      name="pic-fade"
      tag="div"
  >
    <img
        v-for="picture in pictures"
        :key="picture.id"
        :src="picture.file_url"
        class="pic-container__contain"
        :alt="showErrors ? t('invalid_url_label') : ''"
        v-show="currentPicture.id === picture.id"
    />
  </transition-group>
  <p v-else>
    {{
      currentSettings.remoteFiles === "on"
          ? t("no_urls_message")
          : t("no_uploads_message")
    }}
  </p>
</template>

<script>
module.exports = {
  name: "pictures",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    currentStyles: {
      type: Object,
      required: true
    },
    currentDimensions: {
      type: Object,
      required: false,
    },
    records: {
      type: Array,
      required: false,
    },
    language: {
      type: String,
      required: true,
    },
    locale: {
      type: String,
      required: true,
    },
    backendUrl: {
      type: String,
      required: true,
    },
    fetchAsset: {
      type: Function,
      required: false,
    },
  },
  data: function () {
    return {
      index: 0,
      loading: true,
      pictures: [],
    };
  },
  watch: {
    currentSettings: function (newVal, oldVal) {
      // TODO: Disable rotation if we have just one picture, but re-enable once it's > 1 again
      if (newVal.rotationInterval !== oldVal.rotationInterval) {
        this.stopRotation();
        this.startRotation();
      }
      if (
          newVal.remoteFiles !== oldVal.remoteFiles ||
          newVal.remotePictureUrls !== oldVal.remotePictureUrls ||
          newVal.pictureIds !== oldVal.pictureIds
      ) {
        this.fetchPictures();
      }
    },
  },
  computed: {
    pictureIds: function () {
      return JSON.parse(this.currentSettings.pictureIds);
    },
    remotePictureUrls: function () {
      try {
        return JSON.parse(this.currentSettings.remotePictureUrls);
      } catch (error) {
        return [];
      }
    },
    currentPicture: function () {
      return this.pictures[this.index];
    },
    showErrors: function () {
      return this.$store.getters.showErrorNotifications;
    },
  },
  beforeMount: async function () {
    await this.fetchPictures();
    this.startRotation();
    this.loading = false;
  },
  methods: {
    fetchPictures: async function () {
      if (this.currentSettings.remoteFiles === "on") {
        this.pictures = this.remotePictureUrls.map((url, idx) => {
          return {
            file_url: url,
            id: idx,
          };
        });
      } else {
        const data = await fetch(
            `${this.backendUrl}/pictures/picture_uploads`
        ).then((res) => res.json());
        this.pictures = data.filter((pic) => this.pictureIds.includes(pic.id));
      }
    },
    rotate: function () {
      if (this.index < this.pictures.length - 1) {
        this.index++;
      } else {
        this.index = 0;
      }
    },
    startRotation: function () {
      this.$options.rotateInterval = setInterval(
          this.rotate,
          // safeguard against mangled data from backend
          Number.parseInt(this.currentSettings.rotationInterval || 5) * 1000
      );
    },
    stopRotation: function () {
      clearInterval(this.$options.rotateInterval);
    },
  },
  beforeDestroy: function () {
    this.stopRotation();
  },
  locales: {
    enGb: {
      no_uploads_message: "Please choose some images from your device first",
      no_urls_message: "Please add some image links first",
      invalid_url_label: "Invalid URL. Please check in settings",
    },
    deDe: {
      no_uploads_message: "Bitte wähle zuerst ein paar Bilder von deinem Gerät",
      no_urls_message: "Bitte füge zuerst ein paar Bild-Links ein",
      invalid_url_label: "Ungültige URL. Bitte in den Einstellungen überprüfen",
    },
    frFr: {
      no_uploads_message:
          "Veuillez d'abord choisir des images de votre appareil",
      no_urls_message: "Veuillez d'abord ajouter des liens d'image",
      invalid_url_label: "URL invalide. Veuillez vérifier les paramètres",
    },
    esEs: {
      no_uploads_message: "Elija primero algunas imágenes de su dispositivo",
      no_urls_message: "Primero agregue algunos enlaces de imágenes",
      invalid_url_label: "URL invalida. Por favor revise la configuración",
    },
    plPl: {
      no_uploads_message:
          "Najpierw wybierz kilka obrazów ze swojego urządzenia",
      no_urls_message: "Najpierw dodaj linki do obrazów",
      invalid_url_label: "Nieprawidłowy URL. Proszę sprawdzić ustawienia",
    },
    koKr: {
      no_uploads_message: "먼저 장치에서 일부 이미지를 선택하십시오",
      no_urls_message: "먼저 이미지 링크를 추가하세요.",
      invalid_url_label: "잘못된 URL. 설정에서 확인하십시오",
    },
  },
};
</script>
<style>
.pic-container {
  position: relative;
  height: 100%;
  width: 100%;
  display: flex;
  align-items: inherit;
  justify-content: inherit;
}

.pic-container__contain {
  object-fit: contain;
  max-width: 100%;
  max-height: 100%;
  position: absolute;
}

.pic-fade-enter-active,
.pic-fade-leave-active {
  transition: all 2s ease-in-out 1s;
}

.pic-fade-enter,
.pic-fade-leave-to {
  opacity: 0;
}
</style>
